# Change Log

## [0.10.0](https://github.com/go-swagger/go-swagger/tree/0.10.0) (2017-04-23)
[Full Changelog](https://github.com/go-swagger/go-swagger/compare/0.9.0...0.10.0)

**Implemented enhancements:**

- Expose host and port to service configuration code [\#1002](https://github.com/go-swagger/go-swagger/issues/1002)
- no README in examples/todo-list [\#986](https://github.com/go-swagger/go-swagger/issues/986)
- README instructions don't work for me [\#985](https://github.com/go-swagger/go-swagger/issues/985)
- Brew install should link to go-swagger instead of swagger to avoid conflict with npm swagger [\#983](https://github.com/go-swagger/go-swagger/issues/983)
- Upgrade mailru/easy json to latest version, for Google App Engine [\#947](https://github.com/go-swagger/go-swagger/issues/947)
- Unable to respond with file and application/octet-stream producer [\#943](https://github.com/go-swagger/go-swagger/issues/943)
- APIs.guru: test on 200+ Swagger files for real-life APIs [\#501](https://github.com/go-swagger/go-swagger/issues/501)

**Fixed bugs:**

- Swagger fails to generate code for valid schema [\#1012](https://github.com/go-swagger/go-swagger/issues/1012)
- Wrong context package used in generated code [\#1011](https://github.com/go-swagger/go-swagger/issues/1011)
- Bad code generated for querystring items pattern validation [\#1010](https://github.com/go-swagger/go-swagger/issues/1010)
- How to cleanup resources created by handler post handle? [\#1009](https://github.com/go-swagger/go-swagger/issues/1009)
- x/net/context vs context pkg [\#998](https://github.com/go-swagger/go-swagger/issues/998)
- Missing `gcc` in docker image [\#992](https://github.com/go-swagger/go-swagger/issues/992)
- detection of consumers/producers for codegeneration fails when not top-level [\#987](https://github.com/go-swagger/go-swagger/issues/987)
- Invalid code generating for embedded structures [\#982](https://github.com/go-swagger/go-swagger/issues/982)
- Invalid JSON tags in model [\#981](https://github.com/go-swagger/go-swagger/issues/981)
- todo-list client throws "runtime error: invalid memory address" [\#968](https://github.com/go-swagger/go-swagger/issues/968)
- generate operation --skip-validator does not skip validations [\#924](https://github.com/go-swagger/go-swagger/issues/924)
- go-swagger generating apparently invalid .json file [\#922](https://github.com/go-swagger/go-swagger/issues/922)
- POST client request gets a 415 response [\#893](https://github.com/go-swagger/go-swagger/issues/893)
- "swagger generate model" doesn't generate enum values if "--skip-validator" is passed [\#860](https://github.com/go-swagger/go-swagger/issues/860)

**Closed issues:**

- add description to response [\#989](https://github.com/go-swagger/go-swagger/issues/989)

**Merged pull requests:**

- varname value expression for param items [\#1019](https://github.com/go-swagger/go-swagger/pull/1019) ([casualjim](https://github.com/casualjim))
- verify nested consumer/producer [\#1018](https://github.com/go-swagger/go-swagger/pull/1018) ([casualjim](https://github.com/casualjim))
- fix naming for properties with x-go-name [\#1017](https://github.com/go-swagger/go-swagger/pull/1017) ([casualjim](https://github.com/casualjim))
- \[BREAKING\] configureServer gets an extra string arg for the address of the listener [\#1016](https://github.com/go-swagger/go-swagger/pull/1016) ([casualjim](https://github.com/casualjim))
- fix examples [\#1015](https://github.com/go-swagger/go-swagger/pull/1015) ([casualjim](https://github.com/casualjim))
- Issue \#1012 - restore spec to original after optional validation to avoid side effects [\#1014](https://github.com/go-swagger/go-swagger/pull/1014) ([rupor-github](https://github.com/rupor-github))
- Parse VendorExtensible properties. YAMLBlock parser. [\#1008](https://github.com/go-swagger/go-swagger/pull/1008) ([gaplyk](https://github.com/gaplyk))
- Task: Add Makefile and scripts [\#1004](https://github.com/go-swagger/go-swagger/pull/1004) ([kenjones-cisco](https://github.com/kenjones-cisco))
- Fixes local file $ref resolution on windows [\#1001](https://github.com/go-swagger/go-swagger/pull/1001) ([casualjim](https://github.com/casualjim))
- Circle 2.0 [\#999](https://github.com/go-swagger/go-swagger/pull/999) ([casualjim](https://github.com/casualjim))

\* *This Change Log was automatically generated by [github_changelog_generator](https://github.com/skywinder/Github-Changelog-Generator)*
