# Change Log

## [0.11.0](https://github.com/go-swagger/go-swagger/tree/0.11.0) (2017-07-24)
[Full Changelog](https://github.com/go-swagger/go-swagger/compare/0.10.0...0.11.0)

**Implemented enhancements:**

- Add ability for having a non-strict expander  [\#830](https://github.com/go-swagger/go-swagger/issues/830)
- swagger generate spec: type aliases in query parameters [\#649](https://github.com/go-swagger/go-swagger/issues/649)

**Fixed bugs:**

- Consumes wildcard not working [\#1073](https://github.com/go-swagger/go-swagger/issues/1073)
- How to use produces 'text/plain; charset=utf-8' [\#835](https://github.com/go-swagger/go-swagger/issues/835)
- Security definition could not be resolved in Swagger Editor [\#721](https://github.com/go-swagger/go-swagger/issues/721)

**Closed issues:**

-  incorrect json for overridden `json:"-"` fields from embedded struct [\#1102](https://github.com/go-swagger/go-swagger/issues/1102)
- Swagger UI doesn't pass auth token [\#1100](https://github.com/go-swagger/go-swagger/issues/1100)
- configureServer has incorrect number of arguments [\#1099](https://github.com/go-swagger/go-swagger/issues/1099)
- CR \#1081 introduced non-compiling errors [\#1097](https://github.com/go-swagger/go-swagger/issues/1097)
- Generated code contains compiler error \(assignment count mismatch\) [\#1094](https://github.com/go-swagger/go-swagger/issues/1094)
- why my swagger command line does not have generate command [\#1091](https://github.com/go-swagger/go-swagger/issues/1091)
- How to specify nested required in definitions [\#1080](https://github.com/go-swagger/go-swagger/issues/1080)
- unknown field type ele for [\#1077](https://github.com/go-swagger/go-swagger/issues/1077)
- shadow in generated restapi/server.go [\#1074](https://github.com/go-swagger/go-swagger/issues/1074)
- type=uint64, minimum=0+exclusiveMinimum vs minimum=1 [\#1068](https://github.com/go-swagger/go-swagger/issues/1068)
- Incomplete Documentation for Generate Spec [\#1067](https://github.com/go-swagger/go-swagger/issues/1067)
- Is there anyway to change the response format body when validation error? [\#1061](https://github.com/go-swagger/go-swagger/issues/1061)
- Panic recovery middleware should be able to respond with status code [\#1056](https://github.com/go-swagger/go-swagger/issues/1056)
- Getting started with go-swagger [\#1053](https://github.com/go-swagger/go-swagger/issues/1053)
- Files — returning proper content-type/filenames through runtime.File? [\#1052](https://github.com/go-swagger/go-swagger/issues/1052)
- Could I change a response of when validation error ? [\#1041](https://github.com/go-swagger/go-swagger/issues/1041)
- How to accept an API-KEY? [\#1039](https://github.com/go-swagger/go-swagger/issues/1039)
- Model issues generating swagger.yml from code annotations [\#1038](https://github.com/go-swagger/go-swagger/issues/1038)
- OAuth2 scopes in SecurityDefinitions in spec generation not working [\#1028](https://github.com/go-swagger/go-swagger/issues/1028)
- No paths found in basic net/http Web app [\#1027](https://github.com/go-swagger/go-swagger/issues/1027)
- How to validate the body? [\#1025](https://github.com/go-swagger/go-swagger/issues/1025)

**Merged pull requests:**

- move to golang/dep for vendor mgmt [\#1106](https://github.com/go-swagger/go-swagger/pull/1106) ([casualjim](https://github.com/casualjim))
- add standardized codegen comment [\#1105](https://github.com/go-swagger/go-swagger/pull/1105) ([casualjim](https://github.com/casualjim))
- allow for extra args to be defined on mime types [\#1104](https://github.com/go-swagger/go-swagger/pull/1104) ([casualjim](https://github.com/casualjim))
- Ignored overriden fields fix \#1102 [\#1103](https://github.com/go-swagger/go-swagger/pull/1103) ([smacker](https://github.com/smacker))
- Fix for incomplete PR 1081 [\#1101](https://github.com/go-swagger/go-swagger/pull/1101) ([alexmontecucco](https://github.com/alexmontecucco))
- \[BREAKING\] replace gorilla/context with net.Context [\#1090](https://github.com/go-swagger/go-swagger/pull/1090) ([casualjim](https://github.com/casualjim))
- Generate spec follows alias types [\#1087](https://github.com/go-swagger/go-swagger/pull/1087) ([smacker](https://github.com/smacker))
- fix a shadow in server.gotmpl [\#1082](https://github.com/go-swagger/go-swagger/pull/1082) ([arielt](https://github.com/arielt))
- Discriminator should also contain the base struct [\#1081](https://github.com/go-swagger/go-swagger/pull/1081) ([alexmontecucco](https://github.com/alexmontecucco))
- Fix the example template of default-server. [\#1072](https://github.com/go-swagger/go-swagger/pull/1072) ([hiroara](https://github.com/hiroara))
- fix a typo [\#1071](https://github.com/go-swagger/go-swagger/pull/1071) ([maplain](https://github.com/maplain))
- Enabling filtering by tags [\#1070](https://github.com/go-swagger/go-swagger/pull/1070) ([hmahmood](https://github.com/hmahmood))
- nullableNumber\(\) now handles Exclusive{Max,Min}imum [\#1069](https://github.com/go-swagger/go-swagger/pull/1069) ([maxatome](https://github.com/maxatome))
- docs: Fix external link to semantic validations [\#1058](https://github.com/go-swagger/go-swagger/pull/1058) ([ifraixedes](https://github.com/ifraixedes))
- Parsing of tags in YAML format. [\#1057](https://github.com/go-swagger/go-swagger/pull/1057) ([gaplyk](https://github.com/gaplyk))
- \[BREAKING\] fix a tiny typo from tls-certificate-key to tls-key [\#1055](https://github.com/go-swagger/go-swagger/pull/1055) ([maplain](https://github.com/maplain))
- Use filepath.Rel to determine template name [\#1054](https://github.com/go-swagger/go-swagger/pull/1054) ([ka2n](https://github.com/ka2n))
- Expose extensions [\#1051](https://github.com/go-swagger/go-swagger/pull/1051) ([shashankmehra](https://github.com/shashankmehra))
- helper function for extending a default repositiry of templates [\#1046](https://github.com/go-swagger/go-swagger/pull/1046) ([seifer](https://github.com/seifer))
- Fix 1040: make generation of api key authencator customizable. [\#1045](https://github.com/go-swagger/go-swagger/pull/1045) ([dreamlover](https://github.com/dreamlover))
- Set field default depend on the type of property [\#1044](https://github.com/go-swagger/go-swagger/pull/1044) ([gaplyk](https://github.com/gaplyk))
- Expose operation security and securitydefinitions in templates [\#1037](https://github.com/go-swagger/go-swagger/pull/1037) ([mikkeloscar](https://github.com/mikkeloscar))
- Adding ability to use pre-generated models. [\#1035](https://github.com/go-swagger/go-swagger/pull/1035) ([nickrmc83](https://github.com/nickrmc83))
- Parse Scopes of SecurityDefinitions. Fixes \#1028 [\#1032](https://github.com/go-swagger/go-swagger/pull/1032) ([gaplyk](https://github.com/gaplyk))
- add binary marshaler interface [\#1030](https://github.com/go-swagger/go-swagger/pull/1030) ([casualjim](https://github.com/casualjim))
- Add mixin feature that can merge swagger specs. Issue \#1005 [\#1024](https://github.com/go-swagger/go-swagger/pull/1024) ([msample](https://github.com/msample))
- Add the list of supported consumers and producers [\#1023](https://github.com/go-swagger/go-swagger/pull/1023) ([bobvanluijt](https://github.com/bobvanluijt))



\* *This Change Log was automatically generated by [github_changelog_generator](https://github.com/skywinder/Github-Changelog-Generator)*
