# Change Log

## [0.12.0](https://github.com/go-swagger/go-swagger/tree/0.12.0) (2017-09-11)
[Full Changelog](https://github.com/go-swagger/go-swagger/compare/0.11.0...0.12.0)

**Implemented enhancements:**

- Flag to add a licence/copyright header on generated files  [\#307](https://github.com/go-swagger/go-swagger/issues/307)

**Closed issues:**

- No properties generated in json file for swagger:response [\#1161](https://github.com/go-swagger/go-swagger/issues/1161)
- Can't read $ref Schema properties [\#1159](https://github.com/go-swagger/go-swagger/issues/1159)
- No change to generated code when required is set to true or false for formData parameter of type file [\#1151](https://github.com/go-swagger/go-swagger/issues/1151)
- Invalid code generation - redeclares the same function twice [\#1145](https://github.com/go-swagger/go-swagger/issues/1145)
- is there any option to specify the correct import prefix [\#1142](https://github.com/go-swagger/go-swagger/issues/1142)
- go-openapi/runtime/security - not added to the imports - undefined: security [\#1137](https://github.com/go-swagger/go-swagger/issues/1137)
- Struct with \[\]byte field has wrong type [\#1136](https://github.com/go-swagger/go-swagger/issues/1136)
- How to specify the header name in a Parameters or Response definition? [\#1135](https://github.com/go-swagger/go-swagger/issues/1135)
- Broken go get github.com/go-swagger/go-swagger/cmd/swagger after PR \(\#1130\) [\#1131](https://github.com/go-swagger/go-swagger/issues/1131)
- Generation with custom Template [\#1129](https://github.com/go-swagger/go-swagger/issues/1129)
- go 1.7.x only supported atm ? [\#1127](https://github.com/go-swagger/go-swagger/issues/1127)
- go-swagger route can't handle Chinese characters properly [\#1116](https://github.com/go-swagger/go-swagger/issues/1116)
- Add 'db' tag to struct [\#1113](https://github.com/go-swagger/go-swagger/issues/1113)
- Client code is missing handling of joined\<paramName\> when parameter is in path [\#1111](https://github.com/go-swagger/go-swagger/issues/1111)
- import's are incorrectly generated if $GOPATH is on a symlink [\#1059](https://github.com/go-swagger/go-swagger/issues/1059)
- Code gen: undefined: swag in swag.IsZero [\#656](https://github.com/go-swagger/go-swagger/issues/656)

**Merged pull requests:**

- Test model generator [\#1164](https://github.com/go-swagger/go-swagger/pull/1164) ([joshq00](https://github.com/joshq00))
- Generate models that have x-go-type [\#1163](https://github.com/go-swagger/go-swagger/pull/1163) ([joshq00](https://github.com/joshq00))
- More than one tag on a path causes redundancy in directory structure [\#1160](https://github.com/go-swagger/go-swagger/pull/1160) ([EleanorRigby](https://github.com/EleanorRigby))
- Bugfix/lint errors [\#1156](https://github.com/go-swagger/go-swagger/pull/1156) ([kenjones-cisco](https://github.com/kenjones-cisco))
- Feature: Add Authorizer support [\#1155](https://github.com/go-swagger/go-swagger/pull/1155) ([kenjones-cisco](https://github.com/kenjones-cisco))
- Implement `required:false` for parameter of type File [\#1154](https://github.com/go-swagger/go-swagger/pull/1154) ([khyew](https://github.com/khyew))
- New swagger:ignore annotation to explicitly ignore extraneous models [\#1152](https://github.com/go-swagger/go-swagger/pull/1152) ([iamtheddrman](https://github.com/iamtheddrman))
- Issue \# 1059 : import's are incorrectly generated if $GOPATH is on a symlink.  [\#1150](https://github.com/go-swagger/go-swagger/pull/1150) ([EleanorRigby](https://github.com/EleanorRigby))
- Adds a Copyright comment header to auto generated code files. [\#1148](https://github.com/go-swagger/go-swagger/pull/1148) ([EleanorRigby](https://github.com/EleanorRigby))
- update-vendor [\#1132](https://github.com/go-swagger/go-swagger/pull/1132) ([casualjim](https://github.com/casualjim))
- Update vendor [\#1130](https://github.com/go-swagger/go-swagger/pull/1130) ([casualjim](https://github.com/casualjim))
- Fixing Un/MarshalJSON calls for polymorphic types [\#1128](https://github.com/go-swagger/go-swagger/pull/1128) ([nickrmc83](https://github.com/nickrmc83))
- Copying missing "existing-models" option [\#1125](https://github.com/go-swagger/go-swagger/pull/1125) ([nickrmc83](https://github.com/nickrmc83))
- Ensure extend string formats are validated [\#1124](https://github.com/go-swagger/go-swagger/pull/1124) ([benpye](https://github.com/benpye))
- add support for strfmt.ObjectId [\#1123](https://github.com/go-swagger/go-swagger/pull/1123) ([ultimateboy](https://github.com/ultimateboy))
- Correctly validate each element in array parameter [\#1119](https://github.com/go-swagger/go-swagger/pull/1119) ([benpye](https://github.com/benpye))
- Add path array param [\#1112](https://github.com/go-swagger/go-swagger/pull/1112) ([marclop](https://github.com/marclop))
- Add default imports in templates [\#1110](https://github.com/go-swagger/go-swagger/pull/1110) ([JrCs](https://github.com/JrCs))
- Fix typo in configureAPI logger example [\#1108](https://github.com/go-swagger/go-swagger/pull/1108) ([sapk](https://github.com/sapk))


\* *This Change Log was automatically generated by [github_changelog_generator](https://github.com/skywinder/Github-Changelog-Generator)*
