# Change Log

## [0.13.0](https://github.com/go-swagger/go-swagger/tree/0.13.0) (2017-11-11)
[Full Changelog](https://github.com/go-swagger/go-swagger/compare/0.12.0...0.13.0)

**Fixed bugs:**

- MaxLength for file in form data is not being enforced. [\#1153](https://github.com/go-swagger/go-swagger/issues/1153)
- x-nullable for array values doesn't have any effect [\#774](https://github.com/go-swagger/go-swagger/issues/774)

**Closed issues:**

- Generating spec from generated server broken? [\#1246](https://github.com/go-swagger/go-swagger/issues/1246)
- Server does not validate array type data [\#1245](https://github.com/go-swagger/go-swagger/issues/1245)
- How to make parameters to lower case?  [\#1242](https://github.com/go-swagger/go-swagger/issues/1242)
- Unable to define parameters from URL path [\#1236](https://github.com/go-swagger/go-swagger/issues/1236)
- How to get http.ResponseWriter in the generated code [\#1229](https://github.com/go-swagger/go-swagger/issues/1229)
- time.Time fields doesn't get "type" assigned  [\#1226](https://github.com/go-swagger/go-swagger/issues/1226)
- client generator expects x-class in a different place than is documented [\#1221](https://github.com/go-swagger/go-swagger/issues/1221)
- Model file cannot compile when a string field has both date format and maxLength [\#1220](https://github.com/go-swagger/go-swagger/issues/1220)
- Compiler error from model when pascalized discriminator matches definition name [\#1216](https://github.com/go-swagger/go-swagger/issues/1216)
- Body not being written to request on put [\#1213](https://github.com/go-swagger/go-swagger/issues/1213)
- Any example of oauth2 authentication by google account [\#1212](https://github.com/go-swagger/go-swagger/issues/1212)
- swagger specification validate failed at:  types don't match expect map key string or int got: bool [\#1209](https://github.com/go-swagger/go-swagger/issues/1209)
- Invalid parameter sequence in parameters scanner [\#1207](https://github.com/go-swagger/go-swagger/issues/1207)
- Non required array is not marked as omitempty [\#1206](https://github.com/go-swagger/go-swagger/issues/1206)
- go run petstore got error [\#1204](https://github.com/go-swagger/go-swagger/issues/1204)
- Awkward filenames are generated for some uppercase names [\#1202](https://github.com/go-swagger/go-swagger/issues/1202)
- Body is written to request even when it's empty [\#1199](https://github.com/go-swagger/go-swagger/issues/1199)
- Generated code does not compile: "cannot convert nil to" [\#1197](https://github.com/go-swagger/go-swagger/issues/1197)
- Generate with principal from a vendored package [\#1196](https://github.com/go-swagger/go-swagger/issues/1196)
- Panics on attempt to generate server [\#1192](https://github.com/go-swagger/go-swagger/issues/1192)
- Override client template parameters.gotmpl [\#1190](https://github.com/go-swagger/go-swagger/issues/1190)
- Return error to server [\#1186](https://github.com/go-swagger/go-swagger/issues/1186)
- `swagger generate client` panics [\#1181](https://github.com/go-swagger/go-swagger/issues/1181)
- Recent JSON Marshal/Unmarshal commit broke JSON body parsing [\#1177](https://github.com/go-swagger/go-swagger/issues/1177)
- some codepaths in server generation assume "./src" while other assume "./"  [\#1176](https://github.com/go-swagger/go-swagger/issues/1176)
- Composite Model Generated Structs have changed [\#1172](https://github.com/go-swagger/go-swagger/issues/1172)
- How to get the route name from the handler [\#1168](https://github.com/go-swagger/go-swagger/issues/1168)
- `go-openapi/runtime` introduces backwards incompatible API change [\#1165](https://github.com/go-swagger/go-swagger/issues/1165)
- brew installed binary out of date [\#1162](https://github.com/go-swagger/go-swagger/issues/1162)
- Swager generate panic - commit \#e2bfe4232707b33df6e46519f71f5d22cc6bf63b [\#1158](https://github.com/go-swagger/go-swagger/issues/1158)
- requried doesn't validate params unless the schema is in a definition [\#1147](https://github.com/go-swagger/go-swagger/issues/1147)
- Default value doesn't seem to work [\#1146](https://github.com/go-swagger/go-swagger/issues/1146)
- panic: open pet: no such file or directory [\#1134](https://github.com/go-swagger/go-swagger/issues/1134)
- Generated clients should return errors in all error cases instead of panicking [\#1021](https://github.com/go-swagger/go-swagger/issues/1021)

**Merged pull requests:**

- update vendor and examples [\#1262](https://github.com/go-swagger/go-swagger/pull/1262) ([casualjim](https://github.com/casualjim))
- check for child isinterface [\#1257](https://github.com/go-swagger/go-swagger/pull/1257) ([e-zhang](https://github.com/e-zhang))
- Escape '\*/' within generated comment blocks [\#1255](https://github.com/go-swagger/go-swagger/pull/1255) ([elakito](https://github.com/elakito))
- update vendor [\#1253](https://github.com/go-swagger/go-swagger/pull/1253) ([kreamyx](https://github.com/kreamyx))
- array validations [\#1252](https://github.com/go-swagger/go-swagger/pull/1252) ([kreamyx](https://github.com/kreamyx))
- Remove print statements [\#1251](https://github.com/go-swagger/go-swagger/pull/1251) ([ethantkoenig](https://github.com/ethantkoenig))
- Remove Content-Type for empty responses [\#1249](https://github.com/go-swagger/go-swagger/pull/1249) ([databus23](https://github.com/databus23))
- Add support for example values [\#1248](https://github.com/go-swagger/go-swagger/pull/1248) ([ethantkoenig](https://github.com/ethantkoenig))
- Add json tag to HTTPRequest field in generated params [\#1247](https://github.com/go-swagger/go-swagger/pull/1247) ([databus23](https://github.com/databus23))
- added support for maxLength and minLength for file parameters [\#1241](https://github.com/go-swagger/go-swagger/pull/1241) ([kreamyx](https://github.com/kreamyx))
- update vendor [\#1239](https://github.com/go-swagger/go-swagger/pull/1239) ([casualjim](https://github.com/casualjim))
- handle time.Time properly during parsing go source files [\#1235](https://github.com/go-swagger/go-swagger/pull/1235) ([kreamyx](https://github.com/kreamyx))
- fix request body parameter template [\#1230](https://github.com/go-swagger/go-swagger/pull/1230) ([kreamyx](https://github.com/kreamyx))
- Update verbiage on todo-list tutorial [\#1225](https://github.com/go-swagger/go-swagger/pull/1225) ([jcabmora](https://github.com/jcabmora))
- remove petstore panic [\#1224](https://github.com/go-swagger/go-swagger/pull/1224) ([kreamyx](https://github.com/kreamyx))
- handle model property conflicts when format is "date" or "datetime" [\#1223](https://github.com/go-swagger/go-swagger/pull/1223) ([kreamyx](https://github.com/kreamyx))
- Add extensions available for models [\#1222](https://github.com/go-swagger/go-swagger/pull/1222) ([olegmar](https://github.com/olegmar))
- oauth2 authentication example [\#1219](https://github.com/go-swagger/go-swagger/pull/1219) ([huikang](https://github.com/huikang))
- Fix model generation on discriminator conflict [\#1218](https://github.com/go-swagger/go-swagger/pull/1218) ([grim-luminal](https://github.com/grim-luminal))
- Support adding Vendor Extensions to Infos [\#1215](https://github.com/go-swagger/go-swagger/pull/1215) ([fmauNeko](https://github.com/fmauNeko))
- Only write body to request when the body is not nil [\#1200](https://github.com/go-swagger/go-swagger/pull/1200) ([marclop](https://github.com/marclop))
- Added x-omitempty extension to fix \#774 [\#1189](https://github.com/go-swagger/go-swagger/pull/1189) ([akhobov](https://github.com/akhobov))
- Fix double the typo [\#1185](https://github.com/go-swagger/go-swagger/pull/1185) ([ethantkoenig](https://github.com/ethantkoenig))
- 1. supported custom swagger data type \#1183 [\#1184](https://github.com/go-swagger/go-swagger/pull/1184) ([imiskolee](https://github.com/imiskolee))
- Minor doc change configure\_xxx.go [\#1182](https://github.com/go-swagger/go-swagger/pull/1182) ([aheuermann](https://github.com/aheuermann))
- Updates vendor dep for go-openapi/validate [\#1180](https://github.com/go-swagger/go-swagger/pull/1180) ([EleanorRigby](https://github.com/EleanorRigby))
- Fix generated codes for tuple [\#1179](https://github.com/go-swagger/go-swagger/pull/1179) ([koron](https://github.com/koron))
- Revert "Adds Text Marshal/Unmarshal to model objects. Add String\(\) interface" [\#1178](https://github.com/go-swagger/go-swagger/pull/1178) ([EleanorRigby](https://github.com/EleanorRigby))
- Adds Text Marshal/Unmarshal to model objects. Add String\(\) interface [\#1175](https://github.com/go-swagger/go-swagger/pull/1175) ([EleanorRigby](https://github.com/EleanorRigby))
- Add skip-flatten flag to generate server, client and operation [\#1173](https://github.com/go-swagger/go-swagger/pull/1173) ([EleanorRigby](https://github.com/EleanorRigby))
- Expands spec before generation correctly [\#1167](https://github.com/go-swagger/go-swagger/pull/1167) ([EleanorRigby](https://github.com/EleanorRigby))
- fix a typo in layout description [\#1166](https://github.com/go-swagger/go-swagger/pull/1166) ([allencloud](https://github.com/allencloud))

\* *This Change Log was automatically generated by [github_changelog_generator](https://github.com/skywinder/Github-Changelog-Generator)*