# Change Log

## [0.16.0](https://github.com/go-swagger/go-swagger/tree/0.16.0) (2018-08-11)
[Full Changelog](https://github.com/go-swagger/go-swagger/compare/0.15.0...0.16.0)

**Implemented enhancements:**

- Contributed templates  [\#1625](https://github.com/go-swagger/go-swagger/issues/1625)
- issue with validation of multipleOf with the factor being float [\#1618](https://github.com/go-swagger/go-swagger/issues/1618)
- Server locks up on adding flags with go-flags [\#1473](https://github.com/go-swagger/go-swagger/issues/1473)
- Dependency management v/ generated code [\#1419](https://github.com/go-swagger/go-swagger/issues/1419)
- Replace graceful with built-in methods \(1.8 onwards\) [\#1418](https://github.com/go-swagger/go-swagger/issues/1418)

**Fixed bugs:**

- Generate Server - panic if "type" missing [\#1648](https://github.com/go-swagger/go-swagger/issues/1648)
- Server cannot unmarshal array of polymorphic values [\#1637](https://github.com/go-swagger/go-swagger/issues/1637)
- Client generation fails with 0.15.0, works with 0.14.0 [\#1621](https://github.com/go-swagger/go-swagger/issues/1621)
- \(Un\)MarshalJSON functions ignore part of struct when model is generated with allOf: [\#1617](https://github.com/go-swagger/go-swagger/issues/1617)
- Stack overflow error in swagger validate [\#1614](https://github.com/go-swagger/go-swagger/issues/1614)
- Handle platform-specific file names [\#1596](https://github.com/go-swagger/go-swagger/issues/1596)
- More than one tag on a path breaks server code generation [\#931](https://github.com/go-swagger/go-swagger/issues/931)

**Closed issues:**

- Invalid model generated [\#1653](https://github.com/go-swagger/go-swagger/issues/1653)
- use of closed network connection error on shutdown in 0.15 [\#1650](https://github.com/go-swagger/go-swagger/issues/1650)
- Generating server code changes files randomly with multiple mimetypes [\#1646](https://github.com/go-swagger/go-swagger/issues/1646)

**Merged pull requests:**

- Better example for redirect in operation [\#1657](https://github.com/go-swagger/go-swagger/pull/1657) ([fredbi](https://github.com/fredbi))
- update examples and vendor [\#1656](https://github.com/go-swagger/go-swagger/pull/1656) ([casualjim](https://github.com/casualjim))
- Fix parallel unit test for models  [\#1654](https://github.com/go-swagger/go-swagger/pull/1654) ([fredbi](https://github.com/fredbi))
- Fixes \#1648 \[regression from \#1638: codegen panics when type omitted\] [\#1652](https://github.com/go-swagger/go-swagger/pull/1652) ([fredbi](https://github.com/fredbi))
- fix random ordering of mimetypes in the doc strings on generate [\#1647](https://github.com/go-swagger/go-swagger/pull/1647) ([cp16net](https://github.com/cp16net))
- Acknowledges fix from previous PR \(\#1160\) - added test to CI [\#1643](https://github.com/go-swagger/go-swagger/pull/1643) ([fredbi](https://github.com/fredbi))
- Improves error handling at startup for https server [\#1642](https://github.com/go-swagger/go-swagger/pull/1642) ([fredbi](https://github.com/fredbi))
- Unmarshalling array of polymorphic type in body parameter [\#1641](https://github.com/go-swagger/go-swagger/pull/1641) ([fredbi](https://github.com/fredbi))
- Mangle file names with a specific meaning for go build [\#1640](https://github.com/go-swagger/go-swagger/pull/1640) ([fredbi](https://github.com/fredbi))
- Add support for top-level properties in models with AllOf [\#1639](https://github.com/go-swagger/go-swagger/pull/1639) ([fredbi](https://github.com/fredbi))
- Make format resolving strictly to require a valid pair of type and format. [\#1638](https://github.com/go-swagger/go-swagger/pull/1638) ([co3k](https://github.com/co3k))
- Support go.mod from Go 1.11 [\#1636](https://github.com/go-swagger/go-swagger/pull/1636) ([shaxbee](https://github.com/shaxbee))
- Improvements to minimal flattening [\#1631](https://github.com/go-swagger/go-swagger/pull/1631) ([fredbi](https://github.com/fredbi))
- Reverts silent change brought by \#1612 [\#1630](https://github.com/go-swagger/go-swagger/pull/1630) ([fredbi](https://github.com/fredbi))
- Many shutdown fixes [\#1627](https://github.com/go-swagger/go-swagger/pull/1627) ([Phlamethrower](https://github.com/Phlamethrower))
- Add contributed template option and stratoscale's templates [\#1626](https://github.com/go-swagger/go-swagger/pull/1626) ([michaelf-stratoscale](https://github.com/michaelf-stratoscale))
- optimize to clone schema [\#1620](https://github.com/go-swagger/go-swagger/pull/1620) ([koron](https://github.com/koron))
- Fixes minor glitches in documentation [\#1616](https://github.com/go-swagger/go-swagger/pull/1616) ([fredbi](https://github.com/fredbi))


\* *This Change Log was automatically generated by [github_changelog_generator](https://github.com/skywinder/Github-Changelog-Generator)*