# Change Log

## [v0.17.0](https://github.com/go-swagger/go-swagger/tree/v0.17.0) (2018-10-06)
[Full Changelog](https://github.com/go-swagger/go-swagger/compare/0.16.0...v0.17.0)

**Implemented enhancements:**

- Unused variable in restapi/server.go [\#1692](https://github.com/go-swagger/go-swagger/issues/1692)
- Generate spec in yml format [\#1686](https://github.com/go-swagger/go-swagger/issues/1686)
- Could not get payload or file content from request [\#1666](https://github.com/go-swagger/go-swagger/issues/1666)

**Closed issues:**

- --socket-path is being ignored [\#1740](https://github.com/go-swagger/go-swagger/issues/1740)
- Request context does not flow down handler pipeline \(handler registered i globalmiddleware\) is lost. [\#1733](https://github.com/go-swagger/go-swagger/issues/1733)
- Cannot install go-swagger [\#1728](https://github.com/go-swagger/go-swagger/issues/1728)
- -m, --scan-models missing when compiled using go 1.11 with module support [\#1718](https://github.com/go-swagger/go-swagger/issues/1718)
- Models rendered to file even if imported from external package using x-go-type [\#1710](https://github.com/go-swagger/go-swagger/issues/1710)
- Bug in external type import using x-go-type [\#1703](https://github.com/go-swagger/go-swagger/issues/1703)
- How to receive the shutdown signal from generated server? [\#1695](https://github.com/go-swagger/go-swagger/issues/1695)
- errcheck failed on generated restapi/server.go\#handleInterrupt [\#1689](https://github.com/go-swagger/go-swagger/issues/1689)
- Move to go modules ? [\#1677](https://github.com/go-swagger/go-swagger/issues/1677)
- Move from x/net/context to just context [\#1676](https://github.com/go-swagger/go-swagger/issues/1676)
- tuple unmarshaller fails [\#1673](https://github.com/go-swagger/go-swagger/issues/1673)
- Path parameter with request body [\#1523](https://github.com/go-swagger/go-swagger/issues/1523)

**Merged pull requests:**

- Fix graceful-timeout variable [\#1732](https://github.com/go-swagger/go-swagger/pull/1732) ([gregorhollmig](https://github.com/gregorhollmig))
- Enhance Server to have configurable graceful timeout [\#1730](https://github.com/go-swagger/go-swagger/pull/1730) ([gregorhollmig](https://github.com/gregorhollmig))
- use different bindata binary [\#1723](https://github.com/go-swagger/go-swagger/pull/1723) ([casualjim](https://github.com/casualjim))
- Fix do not generate models with x-go-type extension [\#1717](https://github.com/go-swagger/go-swagger/pull/1717) ([moskal91](https://github.com/moskal91))
- Fix missing error check on s.Shutdown\(\) [\#1715](https://github.com/go-swagger/go-swagger/pull/1715) ([MrLuje](https://github.com/MrLuje))
- Allow to include/exclude routes by their tags [\#1709](https://github.com/go-swagger/go-swagger/pull/1709) ([scf2k](https://github.com/scf2k))
- Support dot in the tag names [\#1706](https://github.com/go-swagger/go-swagger/pull/1706) ([scf2k](https://github.com/scf2k))
- Fix x-go-type imports missing [\#1705](https://github.com/go-swagger/go-swagger/pull/1705) ([moskal91](https://github.com/moskal91))
- Remove unused variable [\#1701](https://github.com/go-swagger/go-swagger/pull/1701) ([jackwilsdon](https://github.com/jackwilsdon))
- Enhance spec  [\#1700](https://github.com/go-swagger/go-swagger/pull/1700) ([chenziliang](https://github.com/chenziliang))
- Add include/exclude parameters to spec generator [\#1698](https://github.com/go-swagger/go-swagger/pull/1698) ([scf2k](https://github.com/scf2k))
- Make extension generation optional [\#1697](https://github.com/go-swagger/go-swagger/pull/1697) ([chenziliang](https://github.com/chenziliang))
- fix minor typo "you" to "your" [\#1694](https://github.com/go-swagger/go-swagger/pull/1694) ([stmuk](https://github.com/stmuk))
- Add yaml format spec support [\#1693](https://github.com/go-swagger/go-swagger/pull/1693) ([chenziliang](https://github.com/chenziliang))
- remove telling user they need to install context package [\#1691](https://github.com/go-swagger/go-swagger/pull/1691) ([etsangsplk](https://github.com/etsangsplk))
- Gave up with parallel testing [\#1669](https://github.com/go-swagger/go-swagger/pull/1669) ([fredbi](https://github.com/fredbi))
- Spelling mistake 🍝 [\#1667](https://github.com/go-swagger/go-swagger/pull/1667) ([frg](https://github.com/frg))
- Fix race condition in unit test [\#1664](https://github.com/go-swagger/go-swagger/pull/1664) ([fredbi](https://github.com/fredbi))
- Improve go.mod support in generator [\#1661](https://github.com/go-swagger/go-swagger/pull/1661) ([mikkeloscar](https://github.com/mikkeloscar))

\* *This Change Log was automatically generated by [github_changelog_generator](https://github.com/skywinder/Github-Changelog-Generator)*
