# Change Log

## [v0.18.0](https://github.com/go-swagger/go-swagger/tree/v0.18.0) (2018-12-22)
[Full Changelog](https://github.com/go-swagger/go-swagger/compare/v0.17.2...v0.18.0)

**Implemented enhancements:**

- Client cannot unmarshal struct [\#1729](https://github.com/go-swagger/go-swagger/issues/1729)
- swagger generation with --with-context result in compiles error [\#1684](https://github.com/go-swagger/go-swagger/issues/1684)
- Can't have server code in subdirectory [\#1624](https://github.com/go-swagger/go-swagger/issues/1624)
- Proposal: x-omitempty for general types [\#1623](https://github.com/go-swagger/go-swagger/issues/1623)
- When generating validations struct pkg references needs to be preserved [\#578](https://github.com/go-swagger/go-swagger/issues/578)

**Fixed bugs:**

- Duplicated parentheses [\#1839](https://github.com/go-swagger/go-swagger/issues/1839)
- Regression with gob encoder optimization [\#1824](https://github.com/go-swagger/go-swagger/issues/1824)
- generated embedded\_spec.go removing refs [\#1816](https://github.com/go-swagger/go-swagger/issues/1816)
- Duplicated imports in configure.go [\#1808](https://github.com/go-swagger/go-swagger/issues/1808)
- Recursive model errors during flattening stage of generate server [\#1796](https://github.com/go-swagger/go-swagger/issues/1796)
- Invalid paths in go generate directive [\#1789](https://github.com/go-swagger/go-swagger/issues/1789)
- race in handleShutdown [\#1781](https://github.com/go-swagger/go-swagger/issues/1781)
- non-compiling code if an API method contains a parameter named 'result' [\#1778](https://github.com/go-swagger/go-swagger/issues/1778)
- Are external references supported? [\#1774](https://github.com/go-swagger/go-swagger/issues/1774)
- One spec in multiple files \(data types logic override\) - error of generating [\#1767](https://github.com/go-swagger/go-swagger/issues/1767)
- go-swagger generate server: minItems \(maxItems\) on array fails during validation.  [\#1755](https://github.com/go-swagger/go-swagger/issues/1755)
- Client wont compile with a route tagged "test"  [\#1683](https://github.com/go-swagger/go-swagger/issues/1683)
- Generate client does not handle "-" dashes in --client-package consistently [\#1157](https://github.com/go-swagger/go-swagger/issues/1157)

**Closed issues:**

- body parameter of type string results in code that doesn't compile [\#1832](https://github.com/go-swagger/go-swagger/issues/1832)
- Add an option for placing the docs/docs.go file [\#1811](https://github.com/go-swagger/go-swagger/issues/1811)
- Deb version 0.17.2 doesn't contain the binary on bintray [\#1793](https://github.com/go-swagger/go-swagger/issues/1793)
- Parameters in swagger:route produce validation warnings [\#1785](https://github.com/go-swagger/go-swagger/issues/1785)
- Do not escape '&' character in json response [\#1763](https://github.com/go-swagger/go-swagger/issues/1763)
- Deb installation is broken with the new version with the "v" prefix [\#1760](https://github.com/go-swagger/go-swagger/issues/1760)
- Validate returns different output in console and logs [\#1722](https://github.com/go-swagger/go-swagger/issues/1722)

**Merged pull requests:**

- Prepare for v0.18.0 release [\#1843](https://github.com/go-swagger/go-swagger/pull/1843) ([casualjim](https://github.com/casualjim))
- FAQ update [\#1842](https://github.com/go-swagger/go-swagger/pull/1842) ([fredbi](https://github.com/fredbi))
- Models: avoids redundant "\(\)" on .ValueExpression [\#1840](https://github.com/go-swagger/go-swagger/pull/1840) ([fredbi](https://github.com/fredbi))
- route: add support description response tag at path [\#1829](https://github.com/go-swagger/go-swagger/pull/1829) ([d7561985](https://github.com/d7561985))
- Fix \#1824 [\#1827](https://github.com/go-swagger/go-swagger/pull/1827) ([fredbi](https://github.com/fredbi))
- Add HandlerAPI\(\) function to stratoscale template [\#1821](https://github.com/go-swagger/go-swagger/pull/1821) ([maxatome](https://github.com/maxatome))
- Remove x net context from generated code [\#1819](https://github.com/go-swagger/go-swagger/pull/1819) ([fredbi](https://github.com/fredbi))
- Acknowledge fix \#1816 with go-openapi updates [\#1818](https://github.com/go-swagger/go-swagger/pull/1818) ([fredbi](https://github.com/fredbi))
- Fixed go generate paths in configure\_xxx.go [\#1810](https://github.com/go-swagger/go-swagger/pull/1810) ([fredbi](https://github.com/fredbi))
- Fixed regression on Windows introduced by \#1804 [\#1809](https://github.com/go-swagger/go-swagger/pull/1809) ([fredbi](https://github.com/fredbi))
- Handle array examples; document Example usage [\#1807](https://github.com/go-swagger/go-swagger/pull/1807) ([leon-barrett](https://github.com/leon-barrett))
- Deprecates `--with-context` option [\#1806](https://github.com/go-swagger/go-swagger/pull/1806) ([fredbi](https://github.com/fredbi))
- Fixes race condition in generated server [\#1805](https://github.com/go-swagger/go-swagger/pull/1805) ([fredbi](https://github.com/fredbi))
- More mangling for generated package names and path [\#1804](https://github.com/go-swagger/go-swagger/pull/1804) ([fredbi](https://github.com/fredbi))
- Fix slice validations in body param [\#1803](https://github.com/go-swagger/go-swagger/pull/1803) ([fredbi](https://github.com/fredbi))
- chore: update vendor for performance [\#1802](https://github.com/go-swagger/go-swagger/pull/1802) ([orisano](https://github.com/orisano))
- Use JSON for examples of type object [\#1801](https://github.com/go-swagger/go-swagger/pull/1801) ([leon-barrett](https://github.com/leon-barrett))
- Fix go vet 11 issue with debugAsJSON func [\#1800](https://github.com/go-swagger/go-swagger/pull/1800) ([fredbi](https://github.com/fredbi))
- Fix flattening spec with remote circular $ref [\#1799](https://github.com/go-swagger/go-swagger/pull/1799) ([fredbi](https://github.com/fredbi))
- Allow '?' character in route path [\#1792](https://github.com/go-swagger/go-swagger/pull/1792) ([andrewmilson](https://github.com/andrewmilson))
- There is a panic when invalid schema of route/operation is used in spec generation. It should prevent it [\#1791](https://github.com/go-swagger/go-swagger/pull/1791) ([marsianin](https://github.com/marsianin))
- fix client cannot unmarshal struct which contains null [\#1788](https://github.com/go-swagger/go-swagger/pull/1788) ([AlexInGitHub](https://github.com/AlexInGitHub))
- Absorbing api names across multiple lines [\#1783](https://github.com/go-swagger/go-swagger/pull/1783) ([liyuankui](https://github.com/liyuankui))
- fixes \#1778. Allow 'result' name for API parameter [\#1780](https://github.com/go-swagger/go-swagger/pull/1780) ([mtfelian](https://github.com/mtfelian))

\* *This Change Log was automatically generated by [github_changelog_generator](https://github.com/skywinder/Github-Changelog-Generator)*
