# Change Log

## [v0.19.0](https://github.com/go-swagger/go-swagger/tree/v0.19.0) (2019-03-24)
[Full Changelog](https://github.com/go-swagger/go-swagger/compare/v0.18.0...v0.19.0)

**Implemented enhancements:**

- Support for parsing property vendor extensions [\#1875](https://github.com/go-swagger/go-swagger/issues/1875)
- Provide check for runtime version [\#818](https://github.com/go-swagger/go-swagger/issues/818)

**Fixed bugs:**

- Broken handling of $ref to a definition which maps to interface{} [\#1859](https://github.com/go-swagger/go-swagger/issues/1859)
- External x-go-type imports not resolved for arrays and references [\#1719](https://github.com/go-swagger/go-swagger/issues/1719)
- Race on call to Serve\(\) and  \_\_\_\_\_Listener\(\) functions [\#1465](https://github.com/go-swagger/go-swagger/issues/1465)
- Responses defined in schema: restapi/operations/xxx\_responses.go:54:18: cannot make type models.YY [\#1260](https://github.com/go-swagger/go-swagger/issues/1260)

**Closed issues:**

- Response struct goes under headers [\#1908](https://github.com/go-swagger/go-swagger/issues/1908)
- swagger generate error [\#1906](https://github.com/go-swagger/go-swagger/issues/1906)
- What should a custom Application Consumer return/produce? [\#1901](https://github.com/go-swagger/go-swagger/issues/1901)
- Server generation is much slower when using "--model-package" [\#1896](https://github.com/go-swagger/go-swagger/issues/1896)
- boolean parameters with default attribute, if parameter is not configured in the json,  swagger will generate a null pointer for this field [\#1892](https://github.com/go-swagger/go-swagger/issues/1892)
- in: body not work as expected? [\#1890](https://github.com/go-swagger/go-swagger/issues/1890)
- Spec generation - Multiple File Upload with multipart form [\#1884](https://github.com/go-swagger/go-swagger/issues/1884)
- omitempty [\#1883](https://github.com/go-swagger/go-swagger/issues/1883)
- Can't docker pull the latest versions by tag [\#1871](https://github.com/go-swagger/go-swagger/issues/1871)
- How to use go-swagger with easyjson? [\#1868](https://github.com/go-swagger/go-swagger/issues/1868)
- validator fails to report path parameters defined defined at operation level [\#1866](https://github.com/go-swagger/go-swagger/issues/1866)
- Invalid auto generated file with type:file in output. [\#1853](https://github.com/go-swagger/go-swagger/issues/1853)
- homebrew installation silently fails on generate [\#1261](https://github.com/go-swagger/go-swagger/issues/1261)

**Merged pull requests:**

- Generate properties with x-order above ones without [\#1907](https://github.com/go-swagger/go-swagger/pull/1907) ([e-nikolov](https://github.com/e-nikolov))
- Server config api operation null check [\#1905](https://github.com/go-swagger/go-swagger/pull/1905) ([kellrott](https://github.com/kellrott))
- Fix some typos [\#1900](https://github.com/go-swagger/go-swagger/pull/1900) ([knweiss](https://github.com/knweiss))
- test coverage increase [\#1889](https://github.com/go-swagger/go-swagger/pull/1889) ([d7561985](https://github.com/d7561985))
- spec gen/response: support swagger:file [\#1888](https://github.com/go-swagger/go-swagger/pull/1888) ([d7561985](https://github.com/d7561985))
- Add support for property extensions [\#1876](https://github.com/go-swagger/go-swagger/pull/1876) ([fdelayen](https://github.com/fdelayen))
- Add online playground to README.md [\#1870](https://github.com/go-swagger/go-swagger/pull/1870) ([jankeromnes](https://github.com/jankeromnes))
- camelize error string to follow go style guide [\#1869](https://github.com/go-swagger/go-swagger/pull/1869) ([Liooo](https://github.com/Liooo))
- Fixed regression following PR \#1849: wrong initializer in response [\#1861](https://github.com/go-swagger/go-swagger/pull/1861) ([fredbi](https://github.com/fredbi))
- Add test case without output file for expand.go [\#1855](https://github.com/go-swagger/go-swagger/pull/1855) ([saromanov](https://github.com/saromanov))
- Models: add support for $ref indirections [\#1849](https://github.com/go-swagger/go-swagger/pull/1849) ([fredbi](https://github.com/fredbi))
- Improved support for x-go-type on compound objects [\#1848](https://github.com/go-swagger/go-swagger/pull/1848) ([fredbi](https://github.com/fredbi))
- Check that only a single parameter is passed. [\#1846](https://github.com/go-swagger/go-swagger/pull/1846) ([AlekSi](https://github.com/AlekSi))
- Correct doc typos [\#1844](https://github.com/go-swagger/go-swagger/pull/1844) ([maxatome](https://github.com/maxatome))

\* *This Change Log was automatically generated by [github_changelog_generator](https://github.com/skywinder/Github-Changelog-Generator)*
