# Changelog

## [v0.28.0](https://github.com/go-swagger/go-swagger/tree/v0.28.0) (2021-10-09)

[Full Changelog](https://github.com/go-swagger/go-swagger/compare/v0.27.0...v0.28.0)

**Fixed bugs:**

- strfmt.bsonobjectid validation fails [\#2616](https://github.com/go-swagger/go-swagger/issues/2616)
- Creating models crash when using $ref on an array [\#2511](https://github.com/go-swagger/go-swagger/issues/2511)

**Closed issues:**

- The CLI should return a JSON output rather than objects [\#2640](https://github.com/go-swagger/go-swagger/issues/2640)
- Log-output is not working for validate command [\#2631](https://github.com/go-swagger/go-swagger/issues/2631)
- unsupported type "invalid type" when add a new empty go file [\#2630](https://github.com/go-swagger/go-swagger/issues/2630)
- how to response different field of response struct by different routes? [\#2629](https://github.com/go-swagger/go-swagger/issues/2629)
- Using swagger:strfmt on a \[\]byte type \(UUID\) infers the type as an array of strings [\#2627](https://github.com/go-swagger/go-swagger/issues/2627)
- "github.com/go-openapi/errors".CompositeError has no field or method ValidateName [\#2623](https://github.com/go-swagger/go-swagger/issues/2623)
- undefined: validate.ReadOnly [\#2613](https://github.com/go-swagger/go-swagger/issues/2613)
- \[BUG\]gen model-package with relative path has incorrect imports from v0.25.0 [\#2608](https://github.com/go-swagger/go-swagger/issues/2608)
- Error: "source formatting on generated source "autoconfigure" failed" on server generate [\#2602](https://github.com/go-swagger/go-swagger/issues/2602)
- Error: "source formatting on generated source "autoconfigure" failed" if StrictResponders and ImplementationPackage were both set for a server generation [\#2601](https://github.com/go-swagger/go-swagger/issues/2601)
- How to change the case style \(pascal, camel\) of a struct tag  [\#2600](https://github.com/go-swagger/go-swagger/issues/2600)
- 05 Method Not Allowed response instead of 400 with incorrect validation details [\#2598](https://github.com/go-swagger/go-swagger/issues/2598)
- Support nested body params for CompositeError [\#2594](https://github.com/go-swagger/go-swagger/issues/2594)
- \[apiKey\] auth by two apikey together\(AND Operation\) [\#2586](https://github.com/go-swagger/go-swagger/issues/2586)
- How to add authInfo to request with generated client [\#2584](https://github.com/go-swagger/go-swagger/issues/2584)
- Is there good to way to omit readonly key [\#2581](https://github.com/go-swagger/go-swagger/issues/2581)
- Generating Spec results in Invalid Type Error [\#2577](https://github.com/go-swagger/go-swagger/issues/2577)
- Integration with viper [\#2572](https://github.com/go-swagger/go-swagger/issues/2572)
- unsupported type "invalid type" [\#2569](https://github.com/go-swagger/go-swagger/issues/2569)
- Cannot install directly from github [\#2560](https://github.com/go-swagger/go-swagger/issues/2560)
- Generated server code with Go v1.15 and above generates deprecation warning for TLSConfig [\#2559](https://github.com/go-swagger/go-swagger/issues/2559)

**Merged pull requests:**

- Add github workflow to validate bindata.go [\#2642](https://github.com/go-swagger/go-swagger/pull/2642) ([youyuanwu](https://github.com/youyuanwu))
- Fix auto-configure example [\#2641](https://github.com/go-swagger/go-swagger/pull/2641) ([youyuanwu](https://github.com/youyuanwu))
- Fix generate server with flag --keep-spec-order [\#2621](https://github.com/go-swagger/go-swagger/pull/2621) ([elipavlov](https://github.com/elipavlov))
- 2617 array params [\#2620](https://github.com/go-swagger/go-swagger/pull/2620) ([dimovnike](https://github.com/dimovnike))
- update build containers to freeze to go 1.15 for now [\#2606](https://github.com/go-swagger/go-swagger/pull/2606) ([casualjim](https://github.com/casualjim))
- Removed bracket that was causeing an error if StrictResponders and Im… [\#2603](https://github.com/go-swagger/go-swagger/pull/2603) ([mattalexx](https://github.com/mattalexx))
- Support nested body params for CompositeError [\#2595](https://github.com/go-swagger/go-swagger/pull/2595) ([veleek](https://github.com/veleek))
- Build from interface panic fix [\#2591](https://github.com/go-swagger/go-swagger/pull/2591) ([Pungyeon](https://github.com/Pungyeon))
- fix a broken link in todo-list tutorial [\#2589](https://github.com/go-swagger/go-swagger/pull/2589) ([rueyaa332266](https://github.com/rueyaa332266))
- remove call to deprecated function `BuildNameToCertificate` [\#2582](https://github.com/go-swagger/go-swagger/pull/2582) ([rcousineau-xandr](https://github.com/rcousineau-xandr))
- Added ppc64le support on circleci & goreleaser [\#2574](https://github.com/go-swagger/go-swagger/pull/2574) ([mgiessing](https://github.com/mgiessing))
- CLI nil ptr dereference bug fix, and support enum completion [\#2571](https://github.com/go-swagger/go-swagger/pull/2571) ([youyuanwu](https://github.com/youyuanwu))
- add option to add your own path [\#2570](https://github.com/go-swagger/go-swagger/pull/2570) ([matthewdaltonamount](https://github.com/matthewdaltonamount))
- CLI code generation is ready for release [\#2562](https://github.com/go-swagger/go-swagger/pull/2562) ([youyuanwu](https://github.com/youyuanwu))
- add enum description [\#2561](https://github.com/go-swagger/go-swagger/pull/2561) ([d0ngw](https://github.com/d0ngw))
- Generate CLI: Able to generate cli for docker, and major functionalities complete [\#2556](https://github.com/go-swagger/go-swagger/pull/2556) ([youyuanwu](https://github.com/youyuanwu))



\* *This Changelog was automatically generated by [github_changelog_generator](https://github.com/github-changelog-generator/github-changelog-generator)*
