# Changelog

## [v0.30.0](https://github.com/go-swagger/go-swagger/tree/v0.30.0) (2022-08-26)

[Full Changelog](https://github.com/go-swagger/go-swagger/compare/v0.29.0...v0.30.0)

**Implemented enhancements:**

- Support for extensions within swagger:route [\#1957](https://github.com/go-swagger/go-swagger/issues/1957)
- How to get enums to show up in a swagger specification? [\#954](https://github.com/go-swagger/go-swagger/issues/954)

**Closed issues:**

- any type \(generics\) [\#2809](https://github.com/go-swagger/go-swagger/issues/2809)
- Question: how to make snakize to ignore some abbreviation? [\#2794](https://github.com/go-swagger/go-swagger/issues/2794)
- Work around for name collisions? [\#2792](https://github.com/go-swagger/go-swagger/issues/2792)
- Specify the same parameter more than one time [\#2786](https://github.com/go-swagger/go-swagger/issues/2786)
- unhandled type to resolve JSON pointer [\#2768](https://github.com/go-swagger/go-swagger/issues/2768)
- Go 1.19 change breaks swagger [\#2759](https://github.com/go-swagger/go-swagger/issues/2759)
- \[CLI\] Generating an empty object using `swagger:type object` does not work as expected. [\#2758](https://github.com/go-swagger/go-swagger/issues/2758)
- generate: Ref property in response doesn't have a description [\#2757](https://github.com/go-swagger/go-swagger/issues/2757)
- swagger generate client returns `info.title in body is required` [\#2739](https://github.com/go-swagger/go-swagger/issues/2739)
- Add trimPrefix and trimSuffix to template FuncMap [\#2737](https://github.com/go-swagger/go-swagger/issues/2737)
- Generated CLI does not compile when using arrays as query parameters [\#2735](https://github.com/go-swagger/go-swagger/issues/2735)
- How can I import from a yaml file [\#2729](https://github.com/go-swagger/go-swagger/issues/2729)
- Middleware not stopping request execution [\#2723](https://github.com/go-swagger/go-swagger/issues/2723)
- @Failure, @Success Response Type Usage Error [\#2722](https://github.com/go-swagger/go-swagger/issues/2722)
- Need to fix the options of `todo-list-server` in todo-list example [\#2716](https://github.com/go-swagger/go-swagger/issues/2716)
- Call for transparent HTTP status codes in generated struct [\#2706](https://github.com/go-swagger/go-swagger/issues/2706)
- strfmt.ObjectId is scanned back as an array of strings [\#2704](https://github.com/go-swagger/go-swagger/issues/2704)
- Cannot convert an expression of the type 'map\[string\]SomeType' to the type 'SomeType' [\#2682](https://github.com/go-swagger/go-swagger/issues/2682)
- Installing go-swagger as Debian packages fails [\#2558](https://github.com/go-swagger/go-swagger/issues/2558)
- swagger:type override is not working [\#2229](https://github.com/go-swagger/go-swagger/issues/2229)
- Generating code for go modules is much slower than under GOPATH [\#1826](https://github.com/go-swagger/go-swagger/issues/1826)

**Merged pull requests:**

- Fixes for go 1.19 [\#2808](https://github.com/go-swagger/go-swagger/pull/2808) ([casualjim](https://github.com/casualjim))
- fixbug: `interface{}` in a `map` as value should be generated/typed to `any` [\#2776](https://github.com/go-swagger/go-swagger/pull/2776) ([emilgpa](https://github.com/emilgpa))
- Fix docker command in install.md [\#2765](https://github.com/go-swagger/go-swagger/pull/2765) ([tingstad](https://github.com/tingstad))
- 1957: Support for extensions within swagger:route [\#2751](https://github.com/go-swagger/go-swagger/pull/2751) ([Huckletoon](https://github.com/Huckletoon))
- \#2748 passing request context to ConextValidate\(\) [\#2749](https://github.com/go-swagger/go-swagger/pull/2749) ([dimovnike](https://github.com/dimovnike))
- support swagger:type on structs [\#2747](https://github.com/go-swagger/go-swagger/pull/2747) ([casualjim](https://github.com/casualjim))
- Add support for template plugins [\#2745](https://github.com/go-swagger/go-swagger/pull/2745) ([kevinbarbour](https://github.com/kevinbarbour))
- Update jwt library [\#2744](https://github.com/go-swagger/go-swagger/pull/2744) ([katyanna](https://github.com/katyanna))
- Add sprig library for template functions. [\#2741](https://github.com/go-swagger/go-swagger/pull/2741) ([kevinbarbour](https://github.com/kevinbarbour))
- Fix issue assigning slice pointer to slice in CLI [\#2736](https://github.com/go-swagger/go-swagger/pull/2736) ([kevinbarbour](https://github.com/kevinbarbour))
- support `MarshalText` in custom type [\#2727](https://github.com/go-swagger/go-swagger/pull/2727) ([emilgpa](https://github.com/emilgpa))
- fixes using indexed property for accessing additional properties [\#2725](https://github.com/go-swagger/go-swagger/pull/2725) ([casualjim](https://github.com/casualjim))
- Update the option --tls-certificate-key to --tls-key of todo-list-server in todo-list example [\#2718](https://github.com/go-swagger/go-swagger/pull/2718) ([nishipy](https://github.com/nishipy))
- support for passing basepath as an argument [\#2713](https://github.com/go-swagger/go-swagger/pull/2713) ([svyotov](https://github.com/svyotov))
- add an interface to deal with client responses based on the status code [\#2708](https://github.com/go-swagger/go-swagger/pull/2708) ([casualjim](https://github.com/casualjim))
- support key non-string in map if the key implements TextMarshaler interface [\#2707](https://github.com/go-swagger/go-swagger/pull/2707) ([emilgpa](https://github.com/emilgpa))
- \#2704 codescan fix for strfmt.ObjectId [\#2705](https://github.com/go-swagger/go-swagger/pull/2705) ([dimovnike](https://github.com/dimovnike))



\* *This Changelog was automatically generated by [github_changelog_generator](https://github.com/github-changelog-generator/github-changelog-generator)*
